import { useState } from "preact/hooks";
import { renderHook, act } from "../src";

describe("useState tests", () => {
  test("should use setState value", () => {
    const { result } = renderHook(() => useState("foo"));

    const [value] = result.current;

    expect(value).toBe("foo");
  });

  test("should update setState value using setter", () => {
    const { result } = renderHook(() => useState("foo"));

    const [_, setValue] = result.current;

    // TS thinks that dispatch could be a number
    // @ts-ignore
    act(() => setValue("bar"));

    const [value] = result.current;

    expect(value).toBe("bar");
  });
});
